﻿using System;
using System.Threading;
using System.Collections;
using System.Diagnostics;
using Microsoft.SPOT;

namespace SemaphoreTest
{
    class Program
    {
        public static MySemaphore semaphore = new MySemaphore(2);

        static void Main(string[] args)
        {
            for (int i = 1; i < 10; i++)
            {
                MyThread myt = new MyThread(i);
                Thread t = new Thread(myt.Work);
                t.Start();
                Thread.Sleep(1000);
            }
            while (true) ;
        }
    }

    public class MyThread
    {
        private int i;

        public MyThread(int o)
        {
            i = o;
        }

        public void Work()
        {
            if (Program.semaphore.WaitOne(false) == false)
            {
                Debug.Print(i.ToString() + ": Cannot start.");
                return;
            }
            Debug.Print(i.ToString() + ": Sleep start.");
            Thread.Sleep(2200);
            Debug.Print(i.ToString() + ": Sleep end.");
            Program.semaphore.Release();
        }
    }

    public class MySemaphore
    {
        private Queue queue;
        private AutoResetEvent autoevent;

        public MySemaphore() : this(0) { }

        public MySemaphore(int count)
        {
            queue = new Queue();
            autoevent = new AutoResetEvent(false);
            for (int i = 0; i < count; i++)
            {
                queue.Enqueue(1);
            }
        }

        public void Release()
        {
            queue.Enqueue(1);
            autoevent.Set();
        }

        public bool WaitOne()
        {
            return WaitOne(true);
        }

        public bool WaitOne(bool exitContext)
        {
            if (queue.Count == 0)
            {
                if (!exitContext)
                {
                    return false;
                }
            }
            while (queue.Dequeue() == null)
            {
                autoevent.WaitOne();
            }
            return true;
        }
    }
}
